Ext.data.JsonP.KISSY_Base_Attribute({"tagname":"class","name":"KISSY.Base.Attribute","extends":null,"mixins":[],"alternateClassNames":[],"aliases":{},"singleton":false,"requires":[],"uses":[],"enum":null,"override":null,"inheritable":null,"inheritdoc":null,"meta":{"private":true},"private":true,"id":"class-KISSY.Base.Attribute","members":{"cfg":[],"property":[],"method":[{"name":"addAttr","tagname":"method","owner":"KISSY.Base.Attribute","meta":{"chainable":true},"id":"method-addAttr"},{"name":"addAttrs","tagname":"method","owner":"KISSY.Base.Attribute","meta":{"chainable":true},"id":"method-addAttrs"},{"name":"get","tagname":"method","owner":"KISSY.Base.Attribute","meta":{},"id":"method-get"},{"name":"getAttrVals","tagname":"method","owner":"KISSY.Base.Attribute","meta":{},"id":"method-getAttrVals"},{"name":"getAttrs","tagname":"method","owner":"KISSY.Base.Attribute","meta":{"private":true},"id":"method-getAttrs"},{"name":"hasAttr","tagname":"method","owner":"KISSY.Base.Attribute","meta":{},"id":"method-hasAttr"},{"name":"removeAttr","tagname":"method","owner":"KISSY.Base.Attribute","meta":{"chainable":true},"id":"method-removeAttr"},{"name":"reset","tagname":"method","owner":"KISSY.Base.Attribute","meta":{"chainable":true},"id":"method-reset"},{"name":"set","tagname":"method","owner":"KISSY.Base.Attribute","meta":{},"id":"method-set"},{"name":"setInternal","tagname":"method","owner":"KISSY.Base.Attribute","meta":{"protected":true},"id":"method-setInternal"}],"event":[],"css_var":[],"css_mixin":[]},"linenr":188,"files":[{"filename":"attribute.js","href":"attribute.html#KISSY-Base-Attribute"}],"html_meta":{"private":null},"statics":{"cfg":[],"property":[],"method":[],"event":[],"css_var":[],"css_mixin":[]},"component":false,"superclasses":[],"subclasses":[],"mixedInto":["KISSY.Base"],"parentMixins":[],"html":"<div><pre class=\"hierarchy\"><h4>Mixed into</h4><div class='dependency'><a href='#!/api/KISSY.Base' rel='KISSY.Base' class='docClass'>KISSY.Base</a></div><h4>Files</h4><div class='dependency'><a href='source/attribute.html#KISSY-Base-Attribute' target='_blank'>attribute.js</a></div></pre><div class='doc-contents'><p class='private'><strong>NOTE</strong> This is a private utility class for internal use by the framework. Don't rely on its existence.</p><p>Attribute provides configurable attribute support along with attribute change events.\nIt is designed to be augmented on to a host class,\nand provides the host with the ability to configure attributes to store and retrieve state,\nalong with attribute change events.</p>\n\n<p>For example, attributes added to the host can be configured:</p>\n\n<ul>\n<li>With a setter function, which can be used to manipulate\nvalues passed to attribute 's <a href=\"#!/api/KISSY.Base.Attribute-method-set\" rel=\"KISSY.Base.Attribute-method-set\" class=\"docClass\">set</a> method, before they are stored.</li>\n<li>With a getter function, which can be used to manipulate stored values,\nbefore they are returned by attribute 's <a href=\"#!/api/KISSY.Base.Attribute-method-get\" rel=\"KISSY.Base.Attribute-method-get\" class=\"docClass\">get</a> method.</li>\n<li>With a validator function, to validate values before they are stored.</li>\n</ul>\n\n\n<p>See the <a href=\"#!/api/KISSY.Base.Attribute-method-addAttr\" rel=\"KISSY.Base.Attribute-method-addAttr\" class=\"docClass\">addAttr</a> method, for the complete set of configuration\noptions available for attributes.</p>\n\n<p>NOTE: Most implementations will be better off extending the <a href=\"#!/api/KISSY.Base\" rel=\"KISSY.Base\" class=\"docClass\">KISSY.Base</a> class,\ninstead of augmenting Attribute directly.\nBase augments Attribute and will handle the initial configuration\nof attributes for derived classes, accounting for values passed into the constructor.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-addAttr' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Base.Attribute'>KISSY.Base.Attribute</span><br/><a href='source/attribute.html#KISSY-Base-Attribute-method-addAttr' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Base.Attribute-method-addAttr' class='name expandable'>addAttr</a>( <span class='pre'>name, attrConfig, [override]</span> ) : <a href=\"#!/api/KISSY.Base.Attribute\" rel=\"KISSY.Base.Attribute\" class=\"docClass\">KISSY.Base.Attribute</a><strong class='chainable signature' >chainable</strong></div><div class='description'><div class='short'>Adds an attribute with the provided configuration to the host object. ...</div><div class='long'><p>Adds an attribute with the provided configuration to the host object.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>attrName</p>\n</div></li><li><span class='pre'>attrConfig</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The config supports the following properties</p>\n<ul><li><span class='pre'>value</span> :  (optional)<div class='sub-desc'><p>simple object or system native object</p>\n</div></li><li><span class='pre'>valueFn</span> :  (optional)<div class='sub-desc'><p>a function which can return current attribute 's default value</p>\n</div></li><li><span class='pre'>setter</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> (optional)<div class='sub-desc'><p>call when set attribute 's value\npass current attribute 's value as parameter\nif return value is not undefined,set returned value as real value</p>\n</div></li><li><span class='pre'>getter</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> (optional)<div class='sub-desc'><p>call when get attribute 's value\npass current attribute 's value as parameter\nreturn getter's returned value to invoker</p>\n</div></li><li><span class='pre'>validator</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> (optional)<div class='sub-desc'><p>call before set attribute 's value\nif return false,cancel this set action</p>\n</div></li></ul></div></li><li><span class='pre'>override</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> (optional)<div class='sub-desc'><p>whether override existing attribute config ,default true</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/KISSY.Base.Attribute\" rel=\"KISSY.Base.Attribute\" class=\"docClass\">KISSY.Base.Attribute</a></span><div class='sub-desc'><p>this</p>\n</div></li></ul></div></div></div><div id='method-addAttrs' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Base.Attribute'>KISSY.Base.Attribute</span><br/><a href='source/attribute.html#KISSY-Base-Attribute-method-addAttrs' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Base.Attribute-method-addAttrs' class='name expandable'>addAttrs</a>( <span class='pre'>attrConfigs, initialValues</span> ) : <a href=\"#!/api/KISSY.Base.Attribute\" rel=\"KISSY.Base.Attribute\" class=\"docClass\">KISSY.Base.Attribute</a><strong class='chainable signature' >chainable</strong></div><div class='description'><div class='short'>Configures a group of attributes, and sets initial values. ...</div><div class='long'><p>Configures a group of attributes, and sets initial values.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>attrConfigs</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>An object with attribute name/configuration pairs.</p>\n</div></li><li><span class='pre'>initialValues</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>user defined initial values</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/KISSY.Base.Attribute\" rel=\"KISSY.Base.Attribute\" class=\"docClass\">KISSY.Base.Attribute</a></span><div class='sub-desc'><p>this</p>\n</div></li></ul></div></div></div><div id='method-get' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Base.Attribute'>KISSY.Base.Attribute</span><br/><a href='source/attribute.html#KISSY-Base-Attribute-method-get' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Base.Attribute-method-get' class='name expandable'>get</a>( <span class='pre'>name</span> ) : *</div><div class='description'><div class='short'>Gets the current value of the attribute. ...</div><div class='long'><p>Gets the current value of the attribute.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>attribute 's name</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>*</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getAttrVals' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Base.Attribute'>KISSY.Base.Attribute</span><br/><a href='source/attribute.html#KISSY-Base-Attribute-method-getAttrVals' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Base.Attribute-method-getAttrVals' class='name expandable'>getAttrVals</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>get un-cloned attr value collections ...</div><div class='long'><p>get un-cloned attr value collections</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getAttrs' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Base.Attribute'>KISSY.Base.Attribute</span><br/><a href='source/attribute.html#KISSY-Base-Attribute-method-getAttrs' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Base.Attribute-method-getAttrs' class='name expandable'>getAttrs</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><strong class='private signature' >private</strong></div><div class='description'><div class='short'>get un-cloned attr config collections ...</div><div class='long'><p>get un-cloned attr config collections</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-hasAttr' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Base.Attribute'>KISSY.Base.Attribute</span><br/><a href='source/attribute.html#KISSY-Base-Attribute-method-hasAttr' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Base.Attribute-method-hasAttr' class='name expandable'>hasAttr</a>( <span class='pre'>name</span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Checks if the given attribute has been added to the host. ...</div><div class='long'><p>Checks if the given attribute has been added to the host.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>attribute name</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-removeAttr' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Base.Attribute'>KISSY.Base.Attribute</span><br/><a href='source/attribute.html#KISSY-Base-Attribute-method-removeAttr' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Base.Attribute-method-removeAttr' class='name expandable'>removeAttr</a>( <span class='pre'>name</span> ) : <a href=\"#!/api/KISSY.Base.Attribute\" rel=\"KISSY.Base.Attribute\" class=\"docClass\">KISSY.Base.Attribute</a><strong class='chainable signature' >chainable</strong></div><div class='description'><div class='short'>Removes an attribute from the host object. ...</div><div class='long'><p>Removes an attribute from the host object.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/KISSY.Base.Attribute\" rel=\"KISSY.Base.Attribute\" class=\"docClass\">KISSY.Base.Attribute</a></span><div class='sub-desc'><p>this</p>\n</div></li></ul></div></div></div><div id='method-reset' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Base.Attribute'>KISSY.Base.Attribute</span><br/><a href='source/attribute.html#KISSY-Base-Attribute-method-reset' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Base.Attribute-method-reset' class='name expandable'>reset</a>( <span class='pre'>name, [opts]</span> ) : <a href=\"#!/api/KISSY.Base.Attribute\" rel=\"KISSY.Base.Attribute\" class=\"docClass\">KISSY.Base.Attribute</a><strong class='chainable signature' >chainable</strong></div><div class='description'><div class='short'>Resets the value of an attribute.just reset what addAttr set\n(not what invoker set when call new Xx(cfg)) ...</div><div class='long'><p>Resets the value of an attribute.just reset what addAttr set\n(not what invoker set when call new Xx(cfg))</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>name of attribute</p>\n</div></li><li><span class='pre'>opts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>some options</p>\n<ul><li><span class='pre'>silent</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> (optional)<div class='sub-desc'><p>whether fire change event</p>\n</div></li></ul></div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/KISSY.Base.Attribute\" rel=\"KISSY.Base.Attribute\" class=\"docClass\">KISSY.Base.Attribute</a></span><div class='sub-desc'><p>this</p>\n</div></li></ul></div></div></div><div id='method-set' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Base.Attribute'>KISSY.Base.Attribute</span><br/><a href='source/attribute.html#KISSY-Base-Attribute-method-set' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Base.Attribute-method-set' class='name expandable'>set</a>( <span class='pre'>name, [value], [opts]</span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Sets the value of an attribute. ...</div><div class='long'><p>Sets the value of an attribute.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>|<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>attribute 's name or attribute name and value map</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>attribute 's value</p>\n</div></li><li><span class='pre'>opts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>some options</p>\n<ul><li><span class='pre'>silent</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> (optional)<div class='sub-desc'><p>whether fire change event</p>\n</div></li></ul></div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p>whether pass validator</p>\n</div></li></ul></div></div></div><div id='method-setInternal' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Base.Attribute'>KISSY.Base.Attribute</span><br/><a href='source/attribute.html#KISSY-Base-Attribute-method-setInternal' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Base.Attribute-method-setInternal' class='name expandable'>setInternal</a>( <span class='pre'>name, value, opts</span> )<strong class='protected signature' >protected</strong></div><div class='description'><div class='short'>internal use, no event involved, just set. ...</div><div class='long'><p>internal use, no event involved, just set.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>opts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div></div></div></div></div>"});